#ifndef __PFKEYLIB_H
#define __PFKEYLIB_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include <string.h>
#include <errno.h>
#include <stdint.h>


#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#include "freeswan.h"
#include <net/pfkeyv2.h>
#include <net/pfkey.h>


int pfkey_send_getspi(int       socket,
		uint8_t         satype,
		uint32_t        seq,
		uint8_t		proto,
		struct  sockaddr* address_src,
		uint8_t         prefixlen_src,
		struct  sockaddr* address_dst,
		uint8_t         prefixlen_dst,
		uint32_t        spimin,
		uint32_t        spimax);

int pfkey_send_update(int          socket,
                uint8_t         satype,
                uint32_t        seq,
                uint32_t        spi,
                uint8_t         replay,
                uint8_t         state,
                uint8_t         proto,
                uint8_t         flags,
                struct sockaddr* src,
                uint8_t         prefixlen_src,
                struct sockaddr* dst,
                uint8_t         prefixlen_dst,
                uint32_t        lt_alc_hard,
                uint64_t        lt_byt_hard,
                uint64_t        lt_add_hard,
                uint64_t        lt_use_hard,
                uint32_t        lt_alc_soft,
                uint64_t        lt_byt_soft,
                uint64_t        lt_add_soft,
                uint64_t        lt_use_soft,
                uint8_t         auth_algo,
                uint16_t        auth_keybits,
                caddr_t         auth_key,
                uint8_t         esp_algo, 
                uint16_t        esp_keybits,
                caddr_t         esp_key);

int pfkey_send_add(int          socket,
                uint8_t         satype,
                uint32_t        seq,
                uint32_t        spi,
                uint8_t         replay,
                uint8_t         state,
                uint8_t         proto,
                uint8_t         flags,
                struct sockaddr* src,
                uint8_t         prefixlen_src,
                struct sockaddr* dst,
                uint8_t         prefixlen_dst,
                uint32_t        lt_alc_hard,
                uint64_t        lt_byt_hard,
                uint64_t        lt_add_hard,
                uint64_t        lt_use_hard,
                uint32_t        lt_alc_soft,
                uint64_t        lt_byt_soft,
                uint64_t        lt_add_soft,
                uint64_t        lt_use_soft,
                uint8_t         auth_algo,
                uint16_t        auth_keybits,
                caddr_t         auth_key,
                uint8_t         esp_algo, 
                uint16_t        esp_keybits,
                caddr_t         esp_key);

int pfkey_send_delete(int	socket,
                uint8_t         satype,
                uint32_t        seq,
                uint32_t        spi,
                uint8_t         proto,
                struct sockaddr* src,
                uint8_t         prefixlen_src,
                struct sockaddr* dst,
                uint8_t         prefixlen_dst);

int pfkey_send_flush(int	socket,
		uint8_t		satype,
		uint32_t	seq);

int pfkey_send_addflow(int      socket,
		uint8_t         satype,
		uint32_t        seq,
		uint32_t        spi,
		uint8_t         proto,
		struct sockaddr* address_src,
		uint8_t         prefixlen_src,
		struct sockaddr* address_dst,
		uint8_t         prefixlen_dst);

int pfkey_send_delflow(int      socket,
		uint8_t         satype,
		uint32_t        seq,
		uint32_t        spi,
		uint8_t         proto,
		struct sockaddr* address_src,
		uint8_t         prefixlen_src,
		struct sockaddr* address_dst,
		uint8_t         prefixlen_dst);

#endif /* __PFKEYLIB_H */
